package cn.net.cpzslibs.prot.handset.jinLiquor;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.SingleLabelIdBean;
import cn.net.cpzslibs.prot.handset.bean.res.jinLiquor.Jin20012ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Jin20012ReqPalletLackCount extends ProtBase {
	
	private final short iTaskCode20012 = 20012;
	private Gson gson;
	private Jin20012ResBean resBean;
	private String original_box_label;
	
	public Jin20012ReqPalletLackCount() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public Jin20012ResBean getResBean(){
		return this.resBean;
	}
	
	public void reqPalletSpec(SocketCreate create, SingleLabelIdBean reqBean) throws IOException {
		original_box_label = reqBean.getLabel_id();
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, SingleLabelIdBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20012, "开始请求信息");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20012, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20012, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Jin20012ResBean.class);
			resBean.setOriginal_box_label(original_box_label);
		}
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, SingleLabelIdBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20012, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
